# $Id: Request.pm 37660 2012-08-28 09:49:55Z wsl $
# $URL: https://svn.uvt.nl/its-id/trunk/sources/kiki/lib/UvT/Kiki/WS/Alias/Delete/Request.pm $

use utf8;
use strict;
use warnings FATAL => 'all';

package UvT::Kiki::WS::Alias::Delete::Request;

use UvT::Kiki::WS::Alias::Request -self;

field note => sub { shift->new_alias; return };

field new_alias => sub {
	my $self = shift;

	my $alias = super;

	if($self->nonce) {
		my $name = $alias->full;
		my $who = $self->login;
		my $old = $alias->toString;
		my $text = "User $who deleted alias:\n\told: $old\n";

		my $note = $alias->remove;
		$self->note($note);

		if($note->[0] eq 'ok') {
			warn $text;
			$self->mailtje("[kiki] $who deleted $name", $text);
			$self->activate;
		}
	} else {
		$self->note([error => 'session']);
	}

	return $alias;
}
